%Run the SIMULINK model first to generate the data.
%% Load the input-output data from the SIMULINK model
y=data(:,1);
u=data(:,2);
t=0:1:200;

%%%% Converting to deviation variables?
%y=y-y(1);
%u=u-u(1);

% y=diff(y);
% u=diff(u);
% t=0:1:199;

%%% Looking at the response
plot(t,y,'r');
hold on;
plot(t,u,'b');
xlabel('sampling instants')
ylabel('system response')

%%%% Saving the input-output data as an object
dat1=iddata(y,u,1);

%%%Looking at the estimated impulse response
cra(dat1)

%Delay is 2 samples
%Fitting OE model with one pole, one zero and 2 sample delay
Gp1=oe(dat1,[1,1,2])
%Fitting OE model with two poles, one zero and 2 sample delay
Gp2=oe(dat1,[1,2,2])
%Fitting OE model with two poles, two zeros and 2 sample delay
Gp3=oe(dat1,[2,2,2])
%Comparing the Process model fit to the data
compare(dat1,Gp1,Gp2,Gp3,1)

%Extracting the predicted process outputs with Gp1
[yh]=compare(dat1,Gp1,1);

%Computing the residuals
yres=y-yh{1,1}.y;
%Plotting the residuals
plot(yres);
xlabel('sampling instants')
ylabel('Residuals')

% %%%Residual Differencing%%%%
%yres=diff(yres);

%%Now we have to find the order of the noise model 
autocf(yres,50,0);
figure;
pautocf(yres,50);

%Creating another dataset of residuals
dat2=iddata(yres,[],1);
%Fitting ARMA model with one pole, one zero
Gn1=armax(dat2,[1 1])
%Fitting ARMA model with two poles, one zero
Gn2=armax(dat2,[1 2])
%Fitting ARMA model with two poles, two zeros
Gn3=armax(dat2,[2 2])

%Comparing the Noise model fit to the residuls
compare(dat2,Gn1,Gn2,Gn3,1)

%Extracting the predicted noise with Gn2
[Nh]=compare(dat2,Gn2,1);

%New residuls for the noise model
Nres=yres-Nh{1,1}.y;
plot(Nres)
%Validation of the identified noise model
%Method: 1
autocf(Nres,50,0);
figure;
pautocf(Nres,50);
%Method: 2
hist(Nres)

Process_Model=Gp1
Noise_Model=Gn2


